; optimized by iAN CooG/HokutoForce
; 1068 bytes

        ORG $1001 - 2
        DW  $1001
; Zeropage vectors
zp02 = $02 ;(2)
zp_cave_scan = zp02 + 2 ;(16)
zp06 = zp_cave_scan + 2 ;(2)
zp_colram_scan = zp06 + 2 ;(2)
;---------
; Zeropage variables
zp01 = zp02 - 1 ;(1)
zp0A = zp02 + 8 ;(5)
zp0B = zp0A + 1 ;(4)
zp0C = zp0B + 1 ;(5)
zp0D = zp0C + 1 ;(2)
zp0E = zp0D + 1 ;(2)
zp0F = zp0E + 1 ;(4)
zp10 = zp0F + 1 ;(2)
zp11 = zp10 + 1 ;(5)
zp12 = zp11 + 1 ;(2)
zp_current_cave = zp12 + 1 ;(3)
zp14 = zp_current_cave + 1 ;(2)
zp1B = zp10 + $B ;(3)
zp1F = zp10 + $F ;(3)
zp24 = zp10 + $14 ;(3)
zp26 = zp10 + $16  ;(1)
zp27 = zp10 + $17  ;(3)
zp28 = zp10 + $18  ;(1)
zp2A = zp10 + $1A  ;(1)
zp_lifes_left = zp10 + $1E  ;(4)
zp2F = zp10 + $1F  ;(1)
zp35 = zp10 + $25  ;(1)
zp3B = zp10 + $2B  ;(1)
zp3C = zp10 + $2C  ;(1)
zp60 = $60 ;(2)
zp80 = $80 ;(5)
zpA0 = $A0 ;(1)
;---------
V_07EF = $0fEF
;---------
V_3BFF = $3BFF
V_3C1D = $3C1D
V_3C1E = $3C1E
V_7F98 = $7F98
V_D011 = $FF06
V_D012 = $FF1D
V_D018 = $FF13
V_D020 = $FF19
V_D023 = $FF17
V_D024 = $FF18
V_D7FF = $37FF ; color ram
V_DC00 = $DC00
V_DC01 = $DC01
;---------
        DB  "K"-64,"H"-64,$27,$2B,$9E,"4487",$00,$00,$00        ; $1187
S_080D  LDY #$51        ; "Q"
        LDA (zp_cave_scan),Y
        BEQ B_082C
        ; is the object below the current object round?
        ; object is round means: object is one of these: ($0E), $0F, $10, $11, $12, ($13)
        ; We don't know if C=0 or C=1 here
        ; and we don't want to use a  SEC  in order to save one byte.
        SBC #$0E                                       ; ($0E), $0F, $10, $11, $12, ($13) --> ($00), $01, $02, $03, $04, ($05)
                                  ;                              or  --> ($FF), $00, $01, $02, $03, ($04)
        CMP #$05                            ; is $00 .. $04?
        BCS B_0868                          ; is not round
        DEY                       ; can roll left?
        LDA (zp_cave_scan),Y
        LDY #$28
        ORA (zp_cave_scan),Y
        BEQ B_082C
        LDY #$52        ; "R"
        LDA (zp_cave_scan),Y
        LDY #$2A
        ORA (zp_cave_scan),Y
        BNE B_0868
B_082C  TXA
        ORA #$04
        JSR S_08A4      ;
L_0832  LDA #$00
        BPL B_08AC
        LDY #$51        ; "Q"
        LDA (zp_cave_scan),Y
        BEQ B_082C
        ; We don't roll falling boulders in order to save bytes.
        ; When they fall and hit something and could roll, they simply stop falling,
        ; and then roll. That's not exactly like the original BD1, but it's very close.

        ; Check if falling boulder hits a Firefly or Rockford:

        ; all objects that have bit 0 set --> don't crush
        LSR A
        BCS B_0847
        CMP #$05
        BEQ B_084C
        CMP #$0C
        BCS B_084C
B_0847  TXA
        AND #$12
        BPL B_08AC
B_084C  LDA #$2F
B_084E  STA V_0857 + 1  ;
        LDA #$08       ; LDA #$08
        STA zp0C
B_0855  LDX zp0C
V_0857  LDY zp2F,X
        LDA (zp_cave_scan),Y
        CMP #$02
        BEQ B_0864
        LDA #$08
        JSR S_08A4      ;
B_0864  DEC zp0C
        BPL B_0855
B_0868  RTS
;$0869  --------
X_0869  TXA
; $086A
        DB  $4B,$06 ; ALR #6 ; illegal opcode, just like AND #6 followed by LSR
        STA zp0C
        LDX #$03
        LDA #$0A       ; object $0A: Rockford
B_0872  LDY zp35,X
        CMP (zp_cave_scan),Y
        BEQ B_08A0
        DEX
        BPL B_0872
        LDX zp0C
        LDY zp3B,X
        LDA (zp_cave_scan),Y
        BNE B_0895
        DEX
B_0884  TXA
        AND #$03
        ASL A
        ORA #$18        ; object $18: Firefly0;  $1A: Firefly1  ; $1C: Firefly2  ; $1E: Firefly3
        PHA
        TYA
        PHA
        JSR L_0832      ;
        PLA
        TAY
        PLA
        BNE S_08A4      ; branches always
B_0895  LDY zp3C,X
        LDA (zp_cave_scan),Y
        BEQ B_0884
        INX
        LDY #$29
        BPL B_0884
B_08A0  LDA #$32
        BNE B_084E
S_08A4  CPY #$2A
        ADC #$00
        BPL B_08AE
        DEX
        TXA
B_08AC  LDY #$29
B_08AE
        STA (zp_cave_scan),Y
        TAX
        ; update low byte of screen ptr and colram ptr from cave ptr:
        LDA zp_cave_scan
        STA zp06
        STA zp_colram_scan
        ; update high byte of screen ptr and colram ptr from cave ptr:
        LDA zp_cave_scan+1
        EOR #$40           ; EOR #$40
        STA zp06+1
        EOR #$04           ; EOR #$E4
        STA zp_colram_scan+1
        ; store char:
        LDA zp80,X
        AND #$C7
        ORA #$08
        STA (zp06),Y
        ; store color:
        LDA zp80,X
; $08CB
        DB "K8" ; ALR #$38    ; illegal opcode, just like AND #$38 followed by LSR
        LSR A   ; div / 4
        LSR A
        TAX
        LDA zp24,X
        ;;;PHP
        ;;;EOR #$30
        STA (zp_colram_scan),Y
        ;;;EOR #$30
        ;;;PLP
B_08D4  RTS
;$08D5  --------
        ;
        ; *** Start ***
        ;
X_08D5  LDA #$0E
        DEC zp10
        BEQ B_08AE
B_08DB  LDA zp80,X
        EOR #$65
        STA zp80,X
        TXA
B_08E2  BPL B_08AE
        LDA zp11
        BEQ B_08DB
        LDA zp80,X
        BEQ B_08DB
        RTS
;$08ED  --------
        ;
        ; *** Start ***
        ;
X_08ED  BNE B_0955
        ;
        ; check for run/stop key to restart cave:
        ;;LDA V_DC01
        JSR readRunStopState
        BPL B_08A0
        STY zp0F        ; Update counter "Rockford seen alive"
        ;;;LDA V_DC00
        JSR doMyJoyScan
        ; Bit 0..3: Direction up, down, left, right
        ; Bit 4: Fire
        ; Y=41 here
        LDX #$03
B_08FB  LSR A
        BCS B_0900
        LDY zp35,X
B_0900  DEX
        BPL B_08FB
        CPY #$29        ; joystick centered?
        BEQ B_08D4
        LDA (zp_cave_scan),Y
        ; object $00: space
        ; object $01: dirt
        ; object $10: Diamond
        ; object $12: Boulder
        ; object $1B: outbox
        ; is space or dirt? --> Rockford can move
        CMP #$02
        BCC B_0946
        ; diamond? --> Rockford collects diamond, and can move
        CMP #$10
        BEQ B_0935
        ; outbox --> cave won if open
        CMP #$1B
        BEQ B_0963
        ; object $12: Boulder
        CMP #$12
        BNE B_08D4
        ; boulder (and dir = left or right) --> try to push, can move if push successful
        ; check direction:
        TYA
        ; now A=40 when left, A=42 when right,  A=1 when up, A=81 when down.
        LSR A
        BCS B_08D4
        ; OK, dir = left or right
        STY zp0C
        ; now A=20 when left, A=21 when right
        ; we want to get Y=39 when left, Y=43 when right.
        ; we simply use a lookup-table:
        TAX
        LDY V_07EF,X
        ;LDY S_080D - $0D - $10,X
        LDA (zp_cave_scan),Y
        BNE B_0962      ; Rockford cannot push blocked boulder. Rockford cannot move.
        ; Check for random number because we want pushing to succeed in (approx.) 1 out of 4 tries.
                        ; How do we do this using only an absolute minimum of bytes?
                        ; We have Y=39 or Y=43. In PAL systems, $D012 runs from 0 to 311
                        ; but since $D012 contains bits 0..7 only, $D012 actually runs from 0 to 255
                        ; and then from 0 to 55. When we compare Y to $D012, we get a
                        ; (39+39) : 312  resp.  (43+43) : 312 chance,
                        ; that  0.25     resp.  0.27.
                        ; This is really close to a 1 : 4 chance.
        CPY V_D012
        BCC B_0962
        LDA #$12
        JSR S_08A4      ; screen colour mem
        LDY zp0C
        BNE B_0946
B_0935  LDX zp11
        BEQ B_0946
        LDA #$CB
        STA V_3C1D,X
        DEC zp11
        BNE B_0946
        LDA #$07
        STA zp12
B_0946  ;LDA V_DC00
        JSR doMyJoyScan
        AND #$10
        BEQ B_08E2
        LDA #$0A
        JSR S_08A4      ;
        JMP L_0832      ;
        ;
B_0955  JSR S_0958      ;
S_0958  LDA V_D024
        EOR zp27
        EOR zp28
        ; here A = 0
        STA V_D024
B_0962  RTS
;$0963  --------
B_0963  LDA zp11
        BNE B_0962
S_0967  STA zp_cave_scan        ; init zp_cave_scan with #0 for next fade_in
        ; continue with next cave:
        DEC zp_current_cave
        BPL B_0973
        LDY #$03
        STY zp_current_cave
        ; Increase level:
        INC zp14
        ; The player gets an extra life after every completed cave.
        ; Extra life (up to 10 lifes)
B_0973  LDX zp_lifes_left
        CPX #$0A
        ; here still A = 0
        BEQ B_097E
        INC zp_lifes_left
        LDA #$50        ;;; LDA #$0E  ; color new life Rockford in status bar light grey ($0F)
        INX
B_097E  EOR #$01        ;;; EOR #$01  ; color current life Rockford in status bar white ($01)
        STA V_D7FF,X
        PLA
        PLA
        BNE B_09B2
        ;
        ; *** Start ***
        ;
L_0987  SEI
        LDX #$5B ;      LDX #$D7
        ;;;

myInit
        ASL $ff09
        STX $FF3F





        LDA #$00
        STA $ff12
        LDA #$78 + 2       ; slow mode
        STA $ff13
        ;;;
        STX V_D011
        ;;;
        LDA #$38
        STA $ff14
        LDX #$D7
        ;JMP backFromMyInit
backFromMyInit
        ;;;
        TXS
        PHA
B_098F  ; draw 10 Rockfords, and set text color of top two screen lines to black:
        LDA #$09
        STA V_3BFF,X
        LDA #$00
        STA V_D7FF,X
        ; set text color to light grey (color 15) for first 3 Rockfords:
        CPX #$04
        BCS B_09A0
        ;;;DEC V_D7FF,X
        LDA #$51
        STA V_D7FF,X
        LDA #$00
        ;;;
        ; clear zero page:
B_09A0  STA zp01,X
        ; copy initial data to zero page:
        LDA V_0B66,X    ;
        STA zp27,X
        ; copy initial data to stack:
        LDA V_0AD8,X    ; cave_data_for_stack_src
        PHA
        DEX
        BNE B_098F








myStoreFF13

        ;LDA #$00 + 0    ; + 2 for slow mode
        STx V_D018





        ;;
B_09B2  LDA #$A9
        JSR S_0ABC      ; fade in
        ; set up current cave (including colors), and
        ; draw current cave (random objects and fixed objects):
        LDY zp_current_cave
        LDX zp2A,Y
        JSR S_0A39      ;
        ; init number of diamonds needed,
        ; and draw diamonds in dark dirt color in status bar
        LDX #$0A
        STX zp11
        DEX
        LDA #$4B        ; "K" ; char $43: charset for diamond, but in titan color
B_09C5  STA V_3C1E,X
        DEX
        BPL B_09C5
        ; draw titan border:
        ; now X = #$FF
        JSR S_0A8C      ;
        LDA #$B1        ; #$B1 == fade in current cave
        JSR S_0ABC      ;
B_09D3 ;LDA #$FF        ; modify this into  lda #8  to enable cheat mode. Then press key "2" to immediately win cave.
       ;;;;AND V_DC01
       ;;JSR readKeyState+2
       ;BNE B_09DD
       ;; Cheat mode: Immediately win current cave.
       ;; A = 0 here
       ;JSR S_0967      ; never returns
        ; init cave scan:

        ; init cave scan:
B_09DD  LDA #$7C        ; $7C28 to $04 (16bit value)
        STA zp_cave_scan+1
        LDA #$28
        STA zp_cave_scan
        ; flash border when outbox opens:
        LSR zp12
        ROL A
        STA V_D020
        ; animate Firefly charset and color:
        LDX #$07
B_09ED  LDA zp60,X
        EOR #$FF
        STA zp60,X
        DEX
        BPL B_09ED
        ASL A
        BCC B_0A03
        LDA V_D023
        EOR zp26        ; color index 2: dark dirt color
        EOR zp27        ; color index 3: diamond body color
        ;;;
        ;EOR #$30
        ;;;
        STA V_D023      ; $D023: alternating Firefly color

        ; start cave scan:

B_0A03  LDY #$29
; $0A05
        ;;               lda (zp_cave_scan),Y
        ;;               tax
        ; LAX (zp_cave_scan),Y  ; illegal opcode, works like LDA (..),Y followed by TAX
        DB $B3,$04
        LDA zpA0,X
        STA V_0A0C + 1  ;
V_0A0C  JSR S_080D      ; screen colour mem - *** Self mod. indirect jump!
        INC zp_cave_scan        ; End when $8000 reached
        BNE B_0A03
        INC zp_cave_scan+1
        BPL B_0A03
        ; end of cave scan.
        ; Check if Rockford is dead and already lost his current life:
        LDA zp0F
        BEQ B_0A2A
        ; Check if Rockford was seen alive recently:
        DEC zp0F
        BNE B_09D3
        ; cave lost:
        LDX zp_lifes_left
        LDA #$21        ;;;; set dark grey ($0B) color for dead Rockford in status bar
        STA V_D7FF,X
        DEC zp_lifes_left
        ; if there is at least one life left, restart current cave:
        BNE B_09B2

        ; game lost:
        ; The player has to press run/stop or joy fire
        ;  to restart the whole game after he lost his last life.
        ; As long as the player doesn't press run/stop or joy fire, we continue the game loop:

B_0A2A
        JSR doMyJoyScan
        AND #$10        ; joy fire pressed?
        BEQ B_0A36

        JSR readRunStopState
        BMI B_09D3
B_0A36  JMP L_0987      ; restart whole game
        ;
        ; Input: X = initial value for SP to access begin of cave data on stack
S_0A39  TXS
        ; fetch and set initial random seed:
        PLA
        EOR zp14
        STA zp0A
        ; fetch and set initial thresholds, random objects and cave colors:
        LDX #$0C
B_0A41  PLA
        STA zp1B,X
        ;STA V_D018,X   ; store colors in $D021 .. $D024 ; this also overwrites $D019 .. $D020, but we don't care
        ;JMP myStore
myStore
        CPX #$09
        BCC skipMe
        ;ORA #$30
        STA $FF0C,X
skipMe
        ;JMP backFromMyStore
        ; init  decode_cave_rand_obj  with  $01: dirt
backFromMyStore
        STX zp1B
        DEX
        BNE B_0A41
        ; set $D020 to black:
        STX V_D020
        ; clear hi-byte of random seed:
        STX zp0B
        ; generate random cave objects:
        LDA #$7C
        STA zp02+1
        LDY #$78
        ; Get predictable random number:
B_0A57  LDA zp0B
; $0A59
        DB $4B,$01      ; ALR #1 ; illegal opcode, just like AND #1 followed by LSR
        ROR A
        TAX
        LDA zp0A
        LSR A
        STA zp0D
        LDA zp0A
; $0A64
        DB $4B,$01      ; ALR #1 ; illegal opcode, just like AND #1 followed by LSR
        ROR A
        ADC zp0A
        ADC #$13
        STA zp0A
        TXA
        ADC zp0B
        ADC zp0D
        STA zp0B
        LDX #$04
B_0A76  CMP zp1F,X
        BCC B_0A7D
        DEX
        BNE B_0A76
B_0A7D  LDA zp1B,X
        STA (zp02),Y
        ; Since fade out, decode cave and fade in
        ; is so fast, we have to slow things down a little bit
        ; so the player has time to prepare for the next level:
B_0A81  INX
        BNE B_0A81      ; Loop until X is zero
        INY
        BNE B_0A57
        INC zp02+1
        BPL B_0A57
        TSX             ; fall through to next routine to draw cave specific objects
; ------------------------------------------------------------------------
; Input: X = begin of draw commands on stack
;  Each command is 3 bytes:
;   b1  =  length (bits 0..5) and direction (bit 7: 0=right; 1=down)
;   b2  =  adr (lo) of start pos
;   b3  =  bits 0..1: adr (hi) of start pos
;          bits 2..6: object to draw (2x LSR needed)
;          bit 7: if set, quit drawing after this command

S_0A8C  TXS
B_0A8D  LDY #$01
        PLA
        BPL B_0A96
        ; In order to save 2 bytes, we draw all lines that have direction=down
        ; with drawn length = 128 + originally intended length.
        ; To restore the original behaviour, use AND #$7F.
        ;;;                     and #$7F
        LDY #$28
        STY zp10        ; init zp_inbox_delay
        ; We get here everytime when we draw lines that have direction=down,
        ; e.g. the titan borders. So we always get the chance to
        ; init zp_inbox_delay with #40 before a cave starts:
B_0A96  STY zp0E        ; Y = 1 (when direction right) or Y = 40 (when down)
        TAX             ; X = length
        PLA
        TAY             ; Y = adr (lo) of start pos
        PLA
        PHA
        AND #$03
        ORA #$7C
        STA zp02+1      ; adr (hi) of start pos
B_0AA3  PLA
        PHA
; $0AA5
        DB "K",$7C      ; illegal opcode, just like AND #$7C followed by LSR
        LSR A
        ; now A = object and C=0
        STA (zp02),Y
        TYA
        ; we still have C=0, see above.
        ADC zp0E
        TAY
        BCC B_0AB2
        INC zp02+1
B_0AB2  DEX
        BNE B_0AA3
        PLA             ; bit 7 is set when we have to quit drawing
        BPL B_0A8D
        ; restore stack pointer to #$FD so the following RTS fetches the real return adress:
        LDX #$FD
        TXS
        RTS
; ========================================================================

; Input:
;  A:  = #$A9 when fade to titan
;      = #$B1 when fade in current cave
;$0ABC  --------
S_0ABC  STA B_0AC7      ; screen colour mem
        ; We don't need to initialize  zp_cave_scan  with #0 here since it is already #0.
        LDA #$7C
        STA zp_cave_scan+1
        LDY #$50        ; "P"
        STY zp0F        ; Init counter "Rockford seen alive"

        ; Hack: To switch between "fade in current cave" and "fade out to titan"
        ;       we modify  lda (zp_cave_scan),Y  into  lda #$04  and back.
        ; $04: fade in/out titan wall
        ; Since  zp_cave_scan == #$04, we have to modify the command byte only (from $B1 to $A9 and back).
V_0AC7
B_0AC7  LDA (zp_cave_scan),Y
        JSR B_08AE      ;
        ; draw bottom line of titan border and also fill area after cave buffer:
        LDA #$02
        STA V_7F98,Y
        INY
        BNE B_0AC7
        INC zp_cave_scan+1      ; End when $8000 reached
        BPL B_0AC7
V_0AD8  RTS


        DB $78,$00,$08,$95,$78,$08,$95,$77,$88, $0A, $67, $19, $38,$00,$09,$32
        DB $3C,$00,"P"-64,"R"-64,$00,$00,$1E,$69,$3D,$1E,$89,$3E,$01,$A2,"D"-64,"A"-64
        DB $A3,$64,$01,$F6,$EE,"B"-64
        DB $53 ; color cave B "C"-64
V_0B00
        DB $42, $34, $00,"B"-64,"L"-64,$32,$3C,"X"-64,"P"-64,"R"-64,$00,$26,$41,$3D,$26,$59
        DB $3E,$94,$80,$3C,$94,$88,$3C,$94,$90,$3C,$94,$98,$3C,$26,$C9,$00
        DB $26,$B9,$01,$26,$D1,$02,$94,$8C,$00,$03,$31,"G"-64,"C"-64,$59,"G"-64,"A"-64
        DB "Zg",$01,$82,$EF,"A"-64

        DB $6F, $1E, $4E, $00  ; color cave C
        DB $09,"2d",$00,"P"-64,"R"-64
        DB "O"-64,$00,$04,$A2,"D"-64,"A"-64,$A3,$64,$03,$43,"G"-64,"A"-64,$46,$EF,"A"-64

        DB $51, $22, $42, $00 ; color cave D
        DB $1E,$21,$29,$50,$00,"X"-64,"P"-64,"R"-64,$83,$FB,"F"-64,"C"-64,$22
        DB "G"-64,"A"-64,$23,$67,$01,$C6
V_0B66
        DB $EC, $71, $51 ,"H"-64,$74,$5B,$24,$03,"xyzPR",$29,$2A,$28
        DB $51,$01,$00,$02,$2A,$01,$28,$51,$2A,$EB,$BE,$7F,$ED,$BB,$F7,$DD
        DB $F7,$3E,$3E,$1C,$7F,$5D,$3C,"6ww",$00,$DD,$00,$77,$00,$DD
        DB $00,$FF,$E7,$C3,$81,$00,$81,$C3,$E7,$00,$00,$3C,$3C,$3C,$3C,$00
        DB $00,$00,$44,$00,$00,$00,$44,$00,$00,$3C,$7E,$FF,$DF,$BF,$D5,$6A
        DB $3C,$00,$62,$16,$C5,"Zc",$94,$00,$00,"Pe",$00,$6D,"U"-64,"O"-64
        DB "X"-64,$27,$25,$29,$29," /-",$2A,$C3,$C3,"N"-64,"N"-64,$C3,$C3,"N"-64
        DB "N"-64,$8C,$65,$8C,$65,$8C,$8C,$8C,$8C,$ED,$ED,$ED,$ED,$ED,$32,$AA
        DB $AA,$AA,$AA,$EF,$AA,$AA,$AA,$AA,$ED,$0D,$AA,$0D,$AA,$36,$AA,$36
        DB $AA,$69,$D5,$69,$E4,$69,$AA,$69,$AA
        ;











        ;
readRunStopState
        LDA #$7F
readKeyState
        STA $FD30       ; Write to Column select
latch
        STA $FF08       ; Write to Keyboard Latch
        LDA $FF08       ; Read key state
        RTS
        ;
doMyJoyScan
        LDA #$FD
        jsr latch
        ;AND #$8F
        BMI return
        AND #$EF
        ORA #$80
return
        RTS
; EOF
